package metrics.hyperonymy.actual;

import java.io.PrintWriter;

import metrics.Metric;
import AST.ASTNode;
import AST.Access;
import AST.BodyDecl;
import AST.CastExpr;
import AST.MethodDecl;
import AST.ParTypeAccess;
import AST.TypeAccess;

public class Casts implements Metric<BodyDecl> {

	public String getName() {
		return "hyp-act-castDist";
	}

	public void setupHeader(PrintWriter writer) {
		writer.println("project;location;expression type;target type;type distance");
	}
	
	public void calculate(BodyDecl node) {
		// TODO: Distinguishing sub and super classes does not work, hence it is
		//       commented out. It is also not essential for the prototype - just
		//	     interesting.
		// int superCasts = 0;
		// int subCasts = 0;
		java.util.List<ASTNode<?>> casts = node.findChildrenRecursively(CastExpr.class);
		
		for(ASTNode<?> cNode : casts) {
			CastExpr cast = (CastExpr)cNode;
			// if(cast.type().subtype(((TypeAccess)cast.getTypeAccess()).decl())) {
			//	subCasts++;
			// } else {
			//	superCasts++;
			// }
			String exprTypeName = cast.getExpr().type().fullName();
			String targetTypeName = cast.getTypeAccess().type().fullName();
			node.logMetric(this, exprTypeName, targetTypeName, "?");
		}
		// node.logMetric("hyp-act-castFreq", casts.size(), superCasts, subCasts);
	}

}
