package tests.metrics.hyperonymy.actual;

import static org.junit.Assert.*;
import static org.junit.Assert.assertNotNull;

import java.io.PrintWriter;
import java.io.StringWriter;

import org.junit.Test;

import tests.CompileHelper;
import tests.metrics.MetricsTest;

import AST.ASTNode;
import AST.Program;

public class CastsTest implements MetricsTest {
	
	private static final String SAMPLE_1 = SAMPLES_PATH+"Java01.java";
	
	@Test
	public void test() {
		// Setup
		StringWriter distWriterBack = new StringWriter();
		//StringWriter freqWriterBack = new StringWriter();
		ASTNode.setPrintWriter("hyp-act-castDist", new PrintWriter(distWriterBack));
		//ASTNode.setPrintWriter("hyp-act-castFreq", new PrintWriter(freqWriterBack));
		ASTNode.installMetrics();
		
		// Run
		Program program = CompileHelper.compile(SAMPLE_1);
		assertNotNull(program);
		program.setMetricsPath("");
		program.setMetricsProjectName("projectName");
		program.collectMetrics();
		ASTNode.finishMetrics();
		
		// Examine
		String expectedDistLog =
			  "projectName;"+SAMPLE_1+":4;java.lang.Object;java.lang.String;?\n"
			+ "projectName;"+SAMPLE_1+":4;java.lang.String;java.lang.Object;?\n"  
			+ "projectName;"+SAMPLE_1+":10;java.lang.Object;java.lang.String;?\n"
			+ "projectName;"+SAMPLE_1+":10;java.lang.String;java.lang.Object;?\n";
		//String expectedFreqLog =
		//	  "projectName; "+SAMPLE_1+":4; 2; 0; 2\n"
		//	+ "projectName; "+SAMPLE_1+";10; 2; 0; 2\n";
		String distLog = distWriterBack.getBuffer().toString();
		//String freqLog = freqWriterBack.getBuffer().toString();
		assertEquals(expectedDistLog, distLog);
		//assertEquals(expectedFreqLog, freqLog);
	}
}
